<?php


/**
 * Override or insert variables into the node template.
 */
function dawn_preprocess_node(&$variables) {
  if ($variables['view_mode']) {
    $variables['classes_array'][] = 'node-viewmode-'.drupal_clean_css_identifier($variables['view_mode']);
  }
  
    if (isset($variables['node']->type)) {
    $nodetype = $variables['node']->view_mode;
    $nodeviewmode = $variables['node']->type;
    $variables['theme_hook_suggestions'][] = 'node__' . $nodetype;
    $variables['theme_hook_suggestions'][] = 'node__' . $nodetype.'__'.$nodeviewmode;
  }

  
}


/**
 * templete_preprocess_page(&$variables)
 * --> setup bootstrap grids
 */

function dawn_preprocess_page(&$variables) {
  $grid['content']['sm'] = 'col-sm-'.theme_get_setting('dawn_grids_content_sm');
  $grid['sidebar_first']['sm'] = 'col-sm-'.theme_get_setting('dawn_grids_sidebar_first_sm');
  $grid['sidebar_second']['sm'] = 'col-sm-'.theme_get_setting('dawn_grids_sidebar_second_sm');
  $grid['content']['md'] = 'col-md-'.theme_get_setting('dawn_grids_content_md');
  $grid['sidebar_first']['md'] = 'col-md-'.theme_get_setting('dawn_grids_sidebar_first_md');
  $grid['sidebar_second']['md'] = 'col-md-'.theme_get_setting('dawn_grids_sidebar_second_md');
  $grid['content']['lg'] = 'col-lg-'.theme_get_setting('dawn_grids_content_lg');
  $grid['sidebar_first']['lg'] = 'col-lg-'.theme_get_setting('dawn_grids_sidebar_first_lg');
  $grid['sidebar_second']['lg'] = 'col-lg-'.theme_get_setting('dawn_grids_sidebar_second_lg');
  $current= current_path();
  if ($current=='admin/structure/block/demo/dawn'){
    drupal_add_css(drupal_get_path('theme', 'dawn'). '/css/dawn-block-demo.css');
     $regions= system_region_list('dawn');
     
     $grids = '';
     switch(true){
       case  '':
       break;
     }
  $grid_classes = array();
   foreach( $regions as $base => $human){  
     $label = '<dl class="block-region block-grids">';
     switch($base){
       case 'content':
       case 'sidebar_first':
       case 'sidebar_second':
          $items = [
            'col-xs-12',
            $grid[$base]['sm'],
            $grid[$base]['md'],
            $grid[$base]['lg'],
          ];
          $grid_classes[$base] = $items;
          $label .= '<dt>' . t($human) . ' </dt><dd> '. theme('item_list',  ['items'=>$items]) . '</dd>';
      break;
       default:
         $label .= '<dt>' . t($human) . ' </dt>';
     }
     $label .= '</dl">';
     $variables['page'][$base]['block_description']['#markup']  =  $label;
    }
  }

  // add tpl suggestions for node type..
  if (isset($variables['node']->type)) {
    $nodetype = $variables['node']->type;
    $nodeviewmode = $variables['node']->view_mode;
    $variables['theme_hook_suggestions'][] = 'page__node__' . $nodetype;
    $variables['theme_hook_suggestions'][] = 'page__node__' . $nodetype.'__'.$nodeviewmode;
  }

  $variables['maingrids'] ='col-md-9';
  $variables['contentgrids'] = '--';
  $variables['firstsidebargrids'] ='--';
  $variables['secondsidebargrids'] ='--';
  // setup basic first/second column width
  if(@$variables['page']['sidebar_first'] && @$variables['page']['sidebar_second']){
    $variables['contentgrids'] = 'col-md-push-3 col-sm-12 col-md-9';
    $variables['firstsidebargrids'] = ' col-sm-12 col-md-3 col-md-pull-9';
    $variables['secondsidebargrids'] ='col-sm-12 col-md-3 ';
	} elseif(@$variables['page']['sidebar_first'] || @$variables['page']['sidebar_second']){
    if($variables['page']['sidebar_first']){
      //  has first, no second
      $variables['contentgrids'] = 'col-md-push-3 col-sm-12 col-md-9';
      $variables['firstsidebargrids'] =' col-sm-12 col-md-3 col-md-pull-9';
	    $variables['maingrids'] ='col-md-12';
    }
    if(@$variables['page']['sidebar_second']){
      // has second, no first
      $variables['contentgrids'] = 'col-sm-12 col-md-12';
	    $variables['secondsidebargrids'] ='col-sm-12 col-md-3';
    }
	} else{
    $variables['contentgrids'] = 'col-md-12';
    $variables['maingrids'] ='col-md-12';
	}
}


/**
 * introduces #dawn_wrapper_attributes -- allow wrapping of form elelents with more..
 */ 
function dawn_form_element($variables) {
  $element = &$variables['element'];

  // This function is invoked as theme wrapper, but the rendered form element
  // may not necessarily have been processed by form_builder().
  $element += array(
    '#title_display' => 'before',
  );

  // Add element #id for #type 'item'.
  if (isset($element['#markup']) && !empty($element['#id'])) {
    $attributes['id'] = $element['#id'];
  }
  // Add element's #type and #name as class to aid with JS/CSS selectors.
  $attributes['class'] = array('form-item');
  if (!empty($element['#type'])) {
    $attributes['class'][] = 'form-type-' . strtr($element['#type'], '_', '-');
  }
  if (!empty($element['#name'])) {
    $attributes['class'][] = 'form-item-' . strtr($element['#name'], array(' ' => '-', '_' => '-', '[' => '-', ']' => ''));
  }
  // Add a class for disabled elements to facilitate cross-browser styling.
  if (!empty($element['#attributes']['disabled'])) {
    $attributes['class'][] = 'form-disabled';
  }

  $attributes = isset($element['#dawn_wrapper_attributes']) ? array_merge_recursive($attributes, $element['#dawn_wrapper_attributes']) : $attributes ;

  $output = '<div' . drupal_attributes($attributes) . '>' . "\n";

  // If #title is not set, we don't display any label or required marker.
  if (!isset($element['#title'])) {
    $element['#title_display'] = 'none';
  }
  $prefix = isset($element['#field_prefix']) ? '<span class="field-prefix">' . $element['#field_prefix'] . '</span> ' : '';
  $suffix = isset($element['#field_suffix']) ? ' <span class="field-suffix">' . $element['#field_suffix'] . '</span>' : '';

  switch ($element['#title_display']) {
    case 'before':
    case 'invisible':
      $output .= ' ' . theme('form_element_label', $variables);
      $output .= ' ' . $prefix . $element['#children'] . $suffix . "\n";
      break;

    case 'after':
      $output .= ' ' . $prefix . $element['#children'] . $suffix;
      $output .= ' ' . theme('form_element_label', $variables) . "\n";
      break;

    case 'none':
    case 'attribute':
      // Output no label and no required marker, only the children.
      $output .= ' ' . $prefix . $element['#children'] . $suffix . "\n";
      break;
  }
  if (!empty($element['#description'])) {
    $output .= '<div class="description">' . $element['#description'] . "</div>\n";
  }
  $output .= "</div>\n";
  return $output;
}


/**
 * Uses RDFa attributes if the RDF module is enabled
 * 
 */
function dawn_preprocess_html(&$vars) {
  $viewport = array(
    '#tag' => 'meta',
    '#weight' => -1001,
    '#attributes' => array(
      'name' => 'viewport',
      'content' => theme_get_setting('dawn_meta_viewport'),
    ),
  );
  $httpequiv = array(
    '#tag' => 'meta',
    '#weight' => -1001,
    '#attributes' => array(
      'http-equiv' => 'X-UA-Compatible',
      'content' => theme_get_setting('dawn_meta_httpequiv'),
    ),
  );

  // Ensure that the $vars['rdf'] variable is an object.
  if (!isset($vars['rdf']) || !is_object($vars['rdf'])) {
    $vars['rdf'] = new StdClass();
  }
  if (module_exists('rdf')) {
    $vars['doctype'] = '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML+RDFa 1.1//EN">' . "\n";
    $vars['rdf']->version = 'version="HTML+RDFa 1.1"';
    $vars['rdf']->namespaces = $vars['rdf_namespaces'];
    $vars['rdf']->profile = ' profile="' . $vars['grddl_profile'] . '"';
  } else {
    $vars['doctype'] = '<!DOCTYPE html>' . "\n";
    $vars['rdf']->version = '';
    $vars['rdf']->namespaces = '';
    $vars['rdf']->profile = '';
  }
  
 // use the $html5shiv variable in their html.tpl.php
 $shimset = theme_get_setting('dawn_shim');
 //If the theme setting for adding the html5shim is checked, set the variable.
 if ($shimset == 1) {
  $element = array(  
    'element' => array(
      '#tag' => 'script',
      '#value' => '',
      '#attributes' => array(
        'src' => '//html5shiv.googlecode.com/svn/trunk/html5.js',
      ),
    ),
  );
  $script = theme('html_tag', $element);
  $vars['html5shim'] = PHP_EOL . "<!--[if lt IE 9]>" . $script . "<![endif]-->" . PHP_EOL;
 }

}
